## flashrom 0.9.7+r1782

=== Makefile ===
#
# This file is part of the flashrom project.
#
# Copyright (C) 2005 coresystems GmbH <stepan@coresystems.de>
# Copyright (C) 2009,2010,2012 Carl-Daniel Hailfinger
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
#

PROGRAM = flashrom

###############################################################################
# Defaults for the toolchain.

# If you want to cross-compile, just run e.g.
# make CC=i586-pc-msdosdjgpp-gcc
# You may have to specify STRIP/AR/RANLIB as well.
#
# Note for anyone editing this Makefile: gnumake will happily ignore any
# changes in this Makefile to variables set on the command line.
CC      ?= gcc
STRIP   ?= strip
INSTALL = install
DIFF    = diff
PREFIX  ?= /usr/local
MANDIR  ?= $(PREFIX)/share/man
CFLAGS  ?= -Os -Wall -Wshadow
EXPORTDIR ?= .
AR      ?= ar
RANLIB  ?= ranlib
DOSLIBS_BASE ?= ..
# The following parameter changes the default programmer that will be used if there is no -p/--programmer
# argument given when running flashrom. The predefined setting does not enable any default so that every
# user has to declare the programmer he wants to use on every run. The rationale for this to be not set
# (to e.g. the internal programmer) is that forgetting to specify this when working with another programmer
# easily puts the system attached to the default programmer at risk (e.g. you want to flash coreboot to another
# system attached to an external programmer while the default programmer is set to the internal programmer, and
# you forget to use the -p parameter. This would (try to) overwrite the existing firmware of the computer
# running flashrom). Please do not enable this without thinking about the possible consequences. Possible
# values are those specified in enum programmer in programmer.h (which depend on other CONFIG_* options
# evaluated below, namely those that enable/disable the various programmers).
# Compilation will fail for unspecified values.
CONFIG_DEFAULT_PROGRAMMER ?= PROGRAMMER_INVALID

# If your compiler spits out excessive warnings, run make WARNERROR=no
# You shouldn't have to change this flag.
WARNERROR ?= yes

ifeq ($(WARNERROR), yes)
CFLAGS += -Werror
endif

###############################################################################
# General OS-specific settings.
# 1. Prepare for later by gathering information about host and target OS
# 2. Set compiler flags and parameters according to OSes
# 3. Likewise verify user-supplied CONFIG_* variables.

# HOST_OS is only used to work around local toolchain issues.
HOST_OS ?= $(shell uname)
ifeq ($(HOST_OS), MINGW32_NT-5.1)
# Explicitly set CC = gcc on MinGW, otherwise: "cc: command not found".
CC = gcc
endif
ifneq ($(HOST_OS), SunOS)
STRIP_ARGS = -s
endif

# Determine the destination OS.
# IMPORTANT: The following line must be placed before TARGET_OS is ever used
# (of course), but should come after any lines setting CC because the line
# below uses CC itself.
override TARGET_OS := $(strip $(shell LC_ALL=C $(CC) $(CPPFLAGS) -E os.h 2>/dev/null | grep -v '^\#' | grep '"' | cut -f 2 -d'"'))

ifeq ($(TARGET_OS), Darwin)
CPPFLAGS += -I/opt/local/include -I/usr/local/include
LDFLAGS += -L/opt/local/lib -L/usr/local/lib
endif

ifeq ($(TARGET_OS), FreeBSD)
CPPFLAGS += -I/usr/local/include
LDFLAGS += -L/usr/local/lib
endif

ifeq ($(TARGET_OS), OpenBSD)
CPPFLAGS += -I/usr/local/include
LDFLAGS += -L/usr/local/lib
endif

ifeq ($(TARGET_OS), NetBSD)
CPPFLAGS += -I/usr/pkg/include
LDFLAGS += -L/usr/pkg/lib
endif

ifeq ($(TARGET_OS), DragonFlyBSD)
CPPFLAGS += -I/usr/pkg/include
LDFLAGS += -L/usr/pkg/lib
endif

ifeq ($(TARGET_OS), DOS)
EXEC_SUFFIX := .exe
CPPFLAGS += -I$(DOSLIBS_BASE)/libgetopt
# DJGPP has odd uint*_t definitions which cause lots of format string warnings.
CFLAGS += -Wno-format
# FIXME Check if we can achieve the same effect with -L../libgetopt -lgetopt
LIBS += -lgetopt
LDFLAGS += -L$(DOSLIBS_BASE)/libgetopt/
# Bus Pirate, Serprog and PonyProg are not supported under DOS (missing serial support).
ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_BUSPIRATE_SPI=yes
else
override CONFIG_BUSPIRATE_SPI = no
endif
ifeq ($(CONFIG_SERPROG), yes)
UNSUPPORTED_FEATURES += CONFIG_SERPROG=yes
else
override CONFIG_SERPROG = no
endif
ifeq ($(CONFIG_PONY_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_PONY_SPI=yes
else
override CONFIG_PONY_SPI = no
endif
# Dediprog and FT2232 are not supported under DOS (missing USB support).
ifeq ($(CONFIG_DEDIPROG), yes)
UNSUPPORTED_FEATURES += CONFIG_DEDIPROG=yes
else
override CONFIG_DEDIPROG = no
endif
ifeq ($(CONFIG_FT2232_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_FT2232_SPI=yes
else
override CONFIG_FT2232_SPI = no
endif
ifeq ($(CONFIG_USBBLASTER_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_USBBLASTER_SPI=yes
else
override CONFIG_USBBLASTER_SPI = no
endif
endif

# FIXME: Should we check for Cygwin/MSVC as well?
ifeq ($(TARGET_OS), MinGW)
EXEC_SUFFIX := .exe
# MinGW doesn't have the ffs() function, but we can use gcc's __builtin_ffs().
FLASHROM_CFLAGS += -Dffs=__builtin_ffs
# Some functions provided by Microsoft do not work as described in C99 specifications. This macro fixes that
# for MinGW. See http://sourceforge.net/apps/trac/mingw-w64/wiki/printf%20and%20scanf%20family */
FLASHROM_CFLAGS += -D__USE_MINGW_ANSI_STDIO=1
# libusb-win32/libftdi stuff is usually installed in /usr/local.
CPPFLAGS += -I/usr/local/include
LDFLAGS += -L/usr/local/lib
# For now we disable all PCI-based programmers on Windows/MinGW (no libpci).
ifeq ($(CONFIG_INTERNAL), yes)
UNSUPPORTED_FEATURES += CONFIG_INTERNAL=yes
else
override CONFIG_INTERNAL = no
endif
ifeq ($(CONFIG_RAYER_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_RAYER_SPI=yes
else
override CONFIG_RAYER_SPI = no
endif
ifeq ($(CONFIG_NIC3COM), yes)
UNSUPPORTED_FEATURES += CONFIG_NIC3COM=yes
else
override CONFIG_NIC3COM = no
endif
ifeq ($(CONFIG_GFXNVIDIA), yes)
UNSUPPORTED_FEATURES += CONFIG_GFXNVIDIA=yes
else
override CONFIG_GFXNVIDIA = no
endif
ifeq ($(CONFIG_SATASII), yes)
UNSUPPORTED_FEATURES += CONFIG_SATASII=yes
else
override CONFIG_SATASII = no
endif
ifeq ($(CONFIG_ATAHPT), yes)
UNSUPPORTED_FEATURES += CONFIG_ATAHPT=yes
else
override CONFIG_ATAHPT = no
endif
ifeq ($(CONFIG_DRKAISER), yes)
UNSUPPORTED_FEATURES += CONFIG_DRKAISER=yes
else
override CONFIG_DRKAISER = no
endif
ifeq ($(CONFIG_NICREALTEK), yes)
UNSUPPORTED_FEATURES += CONFIG_NICREALTEK=yes
else
override CONFIG_NICREALTEK = no
endif
ifeq ($(CONFIG_NICNATSEMI), yes)
UNSUPPORTED_FEATURES += CONFIG_NICNATSEMI=yes
else
override CONFIG_NICNATSEMI = no
endif
ifeq ($(CONFIG_NICINTEL), yes)
UNSUPPORTED_FEATURES += CONFIG_NICINTEL=yes
else
override CONFIG_NICINTEL = no
endif
ifeq ($(CONFIG_NICINTEL_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_NICINTEL_SPI=yes
else
override CONFIG_NICINTEL_SPI = no
endif
ifeq ($(CONFIG_OGP_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_OGP_SPI=yes
else
override CONFIG_OGP_SPI = no
endif
ifeq ($(CONFIG_SATAMV), yes)
UNSUPPORTED_FEATURES += CONFIG_SATAMV=yes
else
override CONFIG_SATAMV = no
endif
endif

ifeq ($(TARGET_OS), libpayload)
ifeq ($(MAKECMDGOALS),)
.DEFAULT_GOAL := libflashrom.a
$(info Setting default goal to libflashrom.a)
endif
FLASHROM_CFLAGS += -DSTANDALONE
ifeq ($(CONFIG_DUMMY), yes)
UNSUPPORTED_FEATURES += CONFIG_DUMMY=yes
else
override CONFIG_DUMMY = no
endif
# Bus Pirate, Serprog and PonyProg are not supported with libpayload (missing serial support).
ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_BUSPIRATE_SPI=yes
else
override CONFIG_BUSPIRATE_SPI = no
endif
ifeq ($(CONFIG_SERPROG), yes)
UNSUPPORTED_FEATURES += CONFIG_SERPROG=yes
else
override CONFIG_SERPROG = no
endif
ifeq ($(CONFIG_PONY_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_PONY_SPI=yes
else
override CONFIG_PONY_SPI = no
endif
# Dediprog and FT2232 are not supported with libpayload (missing libusb support)
ifeq ($(CONFIG_DEDIPROG), yes)
UNSUPPORTED_FEATURES += CONFIG_DEDIPROG=yes
else
override CONFIG_DEDIPROG = no
endif
ifeq ($(CONFIG_FT2232_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_FT2232_SPI=yes
else
override CONFIG_FT2232_SPI = no
endif
ifeq ($(CONFIG_USBBLASTER_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_USBBLASTER_SPI=yes
else
override CONFIG_USBBLASTER_SPI = no
endif
endif

ifneq ($(TARGET_OS), Linux)
ifeq ($(CONFIG_LINUX_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_LINUX_SPI=yes
else
override CONFIG_LINUX_SPI = no
endif
endif

###############################################################################
# General architecture-specific settings.
# Like above for the OS, below we verify user-supplied options depending on the target architecture.

# Determine the destination processor architecture.
# IMPORTANT: The following line must be placed before ARCH is ever used
# (of course), but should come after any lines setting CC because the line
# below uses CC itself.
override ARCH := $(strip $(shell LC_ALL=C $(CC) $(CPPFLAGS) -E arch.h 2>/dev/null | grep -v '^\#' | grep '"' | cut -f 2 -d'"'))

# PCI port I/O support is unimplemented on PPC/MIPS and unavailable on ARM.
# Right now this means the drivers below only work on x86.
ifneq ($(ARCH), x86)
ifeq ($(CONFIG_NIC3COM), yes)
UNSUPPORTED_FEATURES += CONFIG_NIC3COM=yes
else
override CONFIG_NIC3COM = no
endif
ifeq ($(CONFIG_NICREALTEK), yes)
UNSUPPORTED_FEATURES += CONFIG_NICREALTEK=yes
else
override CONFIG_NICREALTEK = no
endif
ifeq ($(CONFIG_NICNATSEMI), yes)
UNSUPPORTED_FEATURES += CONFIG_NICNATSEMI=yes
else
override CONFIG_NICNATSEMI = no
endif
ifeq ($(CONFIG_RAYER_SPI), yes)
UNSUPPORTED_FEATURES += CONFIG_RAYER_SPI=yes
else
override CONFIG_RAYER_SPI = no
endif
ifeq ($(CONFIG_ATAHPT), yes)
UNSUPPORTED_FEATURES += CONFIG_ATAHPT=yes
else
override CONFIG_ATAHPT = no
endif
ifeq ($(CONFIG_SATAMV), yes)
UNSUPPORTED_FEATURES += CONFIG_SATAMV=yes
else
override CONFIG_SATAMV = no
endif
endif

###############################################################################
# Flash chip drivers and bus support infrastructure.

CHIP_OBJS = jedec.o stm50.o w39.o w29ee011.o \
	sst28sf040.o m29f400bt.o 82802ab.o pm49fl00x.o \
	sst49lfxxxc.o sst_fwhub.o flashchips.o spi.o spi25.o spi25_statusreg.o \
	opaque.o sfdp.o en29lv640b.o at45db.o

###############################################################################
# Library code.

LIB_OBJS = layout.o flashrom.o udelay.o programmer.o

###############################################################################
# Frontend related stuff.

CLI_OBJS = cli_classic.o cli_output.o print.o

# Set the flashrom version string from the highest revision number of the checked out flashrom files.
# Note to packagers: Any tree exported with "make export" or "make tarball"
# will not require subversion. The downloadable snapshots are already exported.
SVNVERSION := $(shell ./util/getrevision.sh -u)

RELEASE := 0.9.7
VERSION := $(RELEASE)-$(SVNVERSION)
RELEASENAME ?= $(VERSION)

SVNDEF := -D'FLASHROM_VERSION="$(VERSION)"'

###############################################################################
# Default settings of CONFIG_* variables.

# Always enable internal/onboard support for now.
CONFIG_INTERNAL ?= yes

# Always enable serprog for now.
CONFIG_SERPROG ?= yes

# RayeR SPIPGM hardware support
CONFIG_RAYER_SPI ?= yes

# PonyProg2000 SPI hardware support
CONFIG_PONY_SPI ?= yes

# Always enable 3Com NICs for now.
CONFIG_NIC3COM ?= yes

# Enable NVIDIA graphics cards. Note: write and erase do not work properly.
CONFIG_GFXNVIDIA ?= yes

=== debian/changelog ===
flashrom (0.9.7+r1782-1) unstable; urgency=high

  * New upstream release (Closes: #746734, #690478).
  * debian/compat: Upgrade from 5 to 9.
  * Standards-Version: 3.9.5 (no changes required).

 -- Uwe Hermann <uwe@debian.org>  Sat, 03 May 2014 17:39:35 +0200

=== debian/control ===
Source: flashrom
Section: electronics
Priority: extra
Maintainer: Uwe Hermann <uwe@debian.org>
Build-Depends: cdbs, debhelper (>= 9.0.0), libpci-dev, libftdi-dev
Standards-Version: 3.9.5
Homepage: http://www.flashrom.org

Package: flashrom
Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-i386 netbsd-i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: dmidecode [i386 ia64 amd64 kfreebsd-i386 knetbsd-i386 kfreebsd-amd64]
Description: Identify, read, write, erase, and verify BIOS/ROM/flash chips
 flashrom is a tool for identifying, reading, writing, verifying and erasing
 flash chips. It's often used to flash BIOS/EFI/coreboot/firmware/optionROM
 images in-system using a supported mainboard, but it also supports flashing of
 network cards (NICs), SATA controller cards, and other external devices which
 can program flash chips.
 .
 It supports a wide range of DIP32, PLCC32, DIP8, SO8/SOIC8, TSOP32/40/48,
 and BGA chips, which use various protocols such as LPC, FWH, parallel
 flash, or SPI.
 .
 The tool can be used to flash BIOS/firmware images for example -- be it
 proprietary BIOS images or coreboot (previously known as LinuxBIOS) images.
 .
 It can also be used to read the current existing BIOS/firmware from a
 flash chip.
 .
 Currently supported programmers include:
 .
   * internal (default, for in-system flashing in the mainboard)
   * dummy (virtual programmer for testing flashrom)
   * nic3com (for flash ROMs on 3COM network cards)
   * nicrealtek (for flash ROMs on Realtek network cards)
   * nicsmc1211 (for flash ROMs on RTL8139-compatible SMC2 network cards)
   * nicnatsemi (for flash ROMs on National Semiconductor DP838* network cards)
   * nicintel (for parallel flash ROMs on Intel 10/100Mbit network cards)
   * nicintel_spi (for SPI flash ROMs on Intel Gigabit network cards)
   * gfxnvidia (for flash ROMs on NVIDIA graphics cards)
   * drkaiser (for flash ROMs on Dr. Kaiser PC-Waechter PCI cards)
   * satasii (for flash ROMs on Silicon Image SATA/IDE controllers)
   * satamv (for flash ROMs on Marvell SATA controllers)
   * atahpt (for flash ROMs on Highpoint ATA/RAID controllers)
   * ft2232_spi (for SPI flash ROMs attached to an FT2232/FT4232H
     family based USB SPI programmer), including the DLP Design DLP-USB1232H,
     FTDI FT2232H Mini-Module, FTDI FT4232H Mini-Module, openbiosprog-spi,
     Amontec JTAGkey/JTAGkey-tiny/JTAGkey-2, Olimex ARM-USB-TINY/-H,
     Olimex ARM-USB-OCD/-H, TIAO USB Multi-Protocol Adapter (TUMPA),
     GOEPEL PicoTAP, and FIC OpenMoko Neo1973 Debug board.
   * serprog (for flash ROMs attached to a programmer speaking serprog),
     including AVR flasher by Urja Rannikko, AVR flasher by eightdot,
     Arduino Mega flasher by fritz, InSystemFlasher by Juhana Helovuo,
     and atmegaXXu2-flasher by Stefan Tauner.
   * buspirate_spi (for SPI flash ROMs attached to a Bus Pirate)
   * dediprog (for SPI flash ROMs attached to a Dediprog SF100)
   * rayer_spi (for SPI flash ROMs attached to a RayeR parport based programmer)
   * pony_spi (for SPI flash ROMs attached to a SI-Prog serial port
     bitbanging adapter)
   * ogp_spi (for SPI flash ROMs on Open Graphics Project graphics card)
   * linux_spi (for SPI flash ROMs accessible via /dev/spidevX.Y on Linux)

## flashrom 0.9.7+r1852

=== debian/changelog ===
flashrom (0.9.7+r1852-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version: 3.9.6 (no changes required).
  * Use 'Architecture: any', flashrom should build/work pretty much everywhere.
  * debian/patches:
      + 10_disable_linuxspi.patch: Drop.
      + 20_svn_version.patch: Update.
  * Shorten dmidecode 'Recommends' to [any-i386 any-amd64 ia64 armhf].
  * Add missing upstream ChangeLog file (via "svn log").

 -- Uwe Hermann <uwe@debian.org>  Mon, 27 Oct 2014 21:20:52 +0100

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,13 @@
 Priority: extra
 Maintainer: Uwe Hermann <uwe@debian.org>
 Build-Depends: cdbs, debhelper (>= 9.0.0), libpci-dev, libftdi-dev
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://www.flashrom.org
 
 Package: flashrom
-Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-i386 netbsd-i386
+Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Recommends: dmidecode [i386 ia64 amd64 kfreebsd-i386 knetbsd-i386 kfreebsd-amd64]
+Recommends: dmidecode [any-i386 any-amd64 ia64 armhf]
 Description: Identify, read, write, erase, and verify BIOS/ROM/flash chips
  flashrom is a tool for identifying, reading, writing, verifying and erasing
  flash chips. It's often used to flash BIOS/EFI/coreboot/firmware/optionROM

## flashrom 0.9.9~rc1+r1942

=== Makefile ===
--- 
+++ 
@@ -29,7 +29,6 @@
 #
 # Note for anyone editing this Makefile: gnumake will happily ignore any
 # changes in this Makefile to variables set on the command line.
-CC      ?= gcc
 STRIP   ?= strip
 INSTALL = install
 DIFF    = diff
@@ -37,9 +36,10 @@
 MANDIR  ?= $(PREFIX)/share/man
 CFLAGS  ?= -Os -Wall -Wshadow
 EXPORTDIR ?= .
-AR      ?= ar
 RANLIB  ?= ranlib
-DOSLIBS_BASE ?= ..
+PKG_CONFIG ?= pkg-config
+BUILD_DETAILS_FILE ?= build_details.txt
+
 # The following parameter changes the default programmer that will be used if there is no -p/--programmer
 # argument given when running flashrom. The predefined setting does not enable any default so that every
 # user has to declare the programmer he wants to use on every run. The rationale for this to be not set
@@ -52,6 +52,11 @@
 # evaluated below, namely those that enable/disable the various programmers).
 # Compilation will fail for unspecified values.
 CONFIG_DEFAULT_PROGRAMMER ?= PROGRAMMER_INVALID
+# The following adds a default parameter for the default programmer set above (only).
+CONFIG_DEFAULT_PROGRAMMER_ARGS ?= ''
+# Example: compiling with
+#   make CONFIG_DEFAULT_PROGRAMMER=PROGRAMMER_SERPROG CONFIG_DEFAULT_PROGRAMMER_ARGS="dev=/dev/ttyUSB0:1500000"
+# would make executing './flashrom' (almost) equivialent to './flashrom -p serprog:dev=/dev/ttyUSB0:1500000'.
 
 # If your compiler spits out excessive warnings, run make WARNERROR=no
 # You shouldn't have to change this flag.
@@ -60,6 +65,29 @@
 ifeq ($(WARNERROR), yes)
 CFLAGS += -Werror
 endif
+
+ifdef LIBS_BASE
+PKG_CONFIG_LIBDIR ?= $(LIBS_BASE)/lib/pkgconfig
+override CPPFLAGS += -I$(LIBS_BASE)/include
+override LDFLAGS += -L$(LIBS_BASE)/lib -Wl,-rpath -Wl,$(LIBS_BASE)/lib
+endif
+
+ifeq ($(CONFIG_STATIC),yes)
+override PKG_CONFIG += --static
+override LDFLAGS += -static
+endif
+
+# Set LC_ALL=C to minimize influences of the locale.
+# However, this won't work for the majority of relevant commands because they use the $(shell) function and
+# GNU make does not relay variables exported within the makefile to their evironment.
+LC_ALL=C
+export LC_ALL
+
+dummy_for_make_3_80:=$(shell printf "Build started on %s\n\n" "$$(date)" >$(BUILD_DETAILS_FILE))
+
+# Provide an easy way to execute a command, print its output to stdout and capture any error message on stderr
+# in the build details file together with the original stdout output.
+debug_shell = $(shell export LC_ALL=C ; { echo 'exec: export LC_ALL=C ; { $(1) ; }' >&2;  { $(1) ; } | tee -a $(BUILD_DETAILS_FILE) ; echo >&2 ; } 2>>$(BUILD_DETAILS_FILE))
 
 ###############################################################################
 # General OS-specific settings.
@@ -81,41 +109,38 @@
 # IMPORTANT: The following line must be placed before TARGET_OS is ever used
 # (of course), but should come after any lines setting CC because the line
 # below uses CC itself.
-override TARGET_OS := $(strip $(shell LC_ALL=C $(CC) $(CPPFLAGS) -E os.h 2>/dev/null | grep -v '^\#' | grep '"' | cut -f 2 -d'"'))
+override TARGET_OS := $(strip $(call debug_shell,$(CC) $(CPPFLAGS) -E os.h 2>/dev/null | grep -v '^\#' | grep '"' | cut -f 2 -d'"'))
 
 ifeq ($(TARGET_OS), Darwin)
-CPPFLAGS += -I/opt/local/include -I/usr/local/include
-LDFLAGS += -L/opt/local/lib -L/usr/local/lib
+override CPPFLAGS += -I/opt/local/include -I/usr/local/include
+override LDFLAGS += -L/opt/local/lib -L/usr/local/lib
 endif
 
 ifeq ($(TARGET_OS), FreeBSD)
-CPPFLAGS += -I/usr/local/include
-LDFLAGS += -L/usr/local/lib
+override CPPFLAGS += -I/usr/local/include
+override LDFLAGS += -L/usr/local/lib
 endif
 
 ifeq ($(TARGET_OS), OpenBSD)
-CPPFLAGS += -I/usr/local/include
-LDFLAGS += -L/usr/local/lib
+override CPPFLAGS += -I/usr/local/include
+override LDFLAGS += -L/usr/local/lib
 endif
 
 ifeq ($(TARGET_OS), NetBSD)
-CPPFLAGS += -I/usr/pkg/include
-LDFLAGS += -L/usr/pkg/lib
+override CPPFLAGS += -I/usr/pkg/include
+override LDFLAGS += -L/usr/pkg/lib
 endif
 
 ifeq ($(TARGET_OS), DragonFlyBSD)
-CPPFLAGS += -I/usr/pkg/include
-LDFLAGS += -L/usr/pkg/lib
+override CPPFLAGS += -I/usr/local/include
+override LDFLAGS += -L/usr/local/lib
 endif
 
 ifeq ($(TARGET_OS), DOS)
 EXEC_SUFFIX := .exe
-CPPFLAGS += -I$(DOSLIBS_BASE)/libgetopt
 # DJGPP has odd uint*_t definitions which cause lots of format string warnings.
-CFLAGS += -Wno-format
-# FIXME Check if we can achieve the same effect with -L../libgetopt -lgetopt
+override CFLAGS += -Wno-format
 LIBS += -lgetopt
-LDFLAGS += -L$(DOSLIBS_BASE)/libgetopt/
 # Bus Pirate, Serprog and PonyProg are not supported under DOS (missing serial support).
 ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
 UNSUPPORTED_FEATURES += CONFIG_BUSPIRATE_SPI=yes
@@ -132,7 +157,7 @@
 else
 override CONFIG_PONY_SPI = no
 endif
-# Dediprog and FT2232 are not supported under DOS (missing USB support).
+# Dediprog, USB-Blaster, PICkit2, CH341A and FT2232 are not supported under DOS (missing USB support).
 ifeq ($(CONFIG_DEDIPROG), yes)
 UNSUPPORTED_FEATURES += CONFIG_DEDIPROG=yes
 else
@@ -147,6 +172,16 @@
 UNSUPPORTED_FEATURES += CONFIG_USBBLASTER_SPI=yes
 else
 override CONFIG_USBBLASTER_SPI = no
+endif
+ifeq ($(CONFIG_PICKIT2_SPI), yes)
+UNSUPPORTED_FEATURES += CONFIG_PICKIT2_SPI=yes
+else
+override CONFIG_PICKIT2_SPI = no
+endif
+ifeq ($(CONFIG_CH341A_SPI), yes)
+UNSUPPORTED_FEATURES += CONFIG_CH341A_SPI=yes
+else
+override CONFIG_CH341A_SPI = no
 endif
 endif
 
@@ -156,11 +191,8 @@
 # MinGW doesn't have the ffs() function, but we can use gcc's __builtin_ffs().
 FLASHROM_CFLAGS += -Dffs=__builtin_ffs
 # Some functions provided by Microsoft do not work as described in C99 specifications. This macro fixes that
-# for MinGW. See http://sourceforge.net/apps/trac/mingw-w64/wiki/printf%20and%20scanf%20family */
+# for MinGW. See http://sourceforge.net/p/mingw-w64/wiki2/printf%20and%20scanf%20family/ */
 FLASHROM_CFLAGS += -D__USE_MINGW_ANSI_STDIO=1
-# libusb-win32/libftdi stuff is usually installed in /usr/local.
-CPPFLAGS += -I/usr/local/include
-LDFLAGS += -L/usr/local/lib
 # For now we disable all PCI-based programmers on Windows/MinGW (no libpci).
 ifeq ($(CONFIG_INTERNAL), yes)
 UNSUPPORTED_FEATURES += CONFIG_INTERNAL=yes
@@ -192,6 +224,21 @@
 else
 override CONFIG_ATAHPT = no
 endif
+ifeq ($(CONFIG_ATAVIA), yes)
+UNSUPPORTED_FEATURES += CONFIG_ATAVIA=yes
+else
+override CONFIG_ATAVIA = no
+endif
+ifeq ($(CONFIG_ATAPROMISE), yes)
+UNSUPPORTED_FEATURES += CONFIG_ATAPROMISE=yes
+else
+override CONFIG_ATAPROMISE = no
+endif
+ifeq ($(CONFIG_IT8212), yes)
+UNSUPPORTED_FEATURES += CONFIG_IT8212=yes
+else
+override CONFIG_IT8212 = no
+endif
 ifeq ($(CONFIG_DRKAISER), yes)
 UNSUPPORTED_FEATURES += CONFIG_DRKAISER=yes
 else
@@ -211,6 +258,11 @@
 UNSUPPORTED_FEATURES += CONFIG_NICINTEL=yes
 else
 override CONFIG_NICINTEL = no
+endif
+ifeq ($(CONFIG_NICINTEL_EEPROM), yes)
+UNSUPPORTED_FEATURES += CONFIG_NICINTEL_EEPROM=yes
+else
+override CONFIG_NICINTEL_EEPROM = no
 endif
 ifeq ($(CONFIG_NICINTEL_SPI), yes)
 UNSUPPORTED_FEATURES += CONFIG_NICINTEL_SPI=yes
@@ -240,6 +292,12 @@
 else
 override CONFIG_DUMMY = no
 endif
+# libpayload does not provide the romsize field in struct pci_dev that the atapromise code requires.
+ifeq ($(CONFIG_ATAPROMISE), yes)
+UNSUPPORTED_FEATURES += CONFIG_ATAPROMISE=yes
+else
+override CONFIG_ATAPROMISE = no
+endif
 # Bus Pirate, Serprog and PonyProg are not supported with libpayload (missing serial support).
 ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
 UNSUPPORTED_FEATURES += CONFIG_BUSPIRATE_SPI=yes
@@ -256,7 +314,7 @@
 else
 override CONFIG_PONY_SPI = no
 endif
-# Dediprog and FT2232 are not supported with libpayload (missing libusb support)
+# Dediprog, USB-Blaster, PICkit2, CH341A and FT2232 are not supported with libpayload (missing libusb support)
 ifeq ($(CONFIG_DEDIPROG), yes)
 UNSUPPORTED_FEATURES += CONFIG_DEDIPROG=yes
 else
@@ -271,6 +329,16 @@
 UNSUPPORTED_FEATURES += CONFIG_USBBLASTER_SPI=yes
 else
 override CONFIG_USBBLASTER_SPI = no
+endif
+ifeq ($(CONFIG_PICKIT2_SPI), yes)
+UNSUPPORTED_FEATURES += CONFIG_PICKIT2_SPI=yes
+else
+override CONFIG_PICKIT2_SPI = no
+endif
+ifeq ($(CONFIG_CH341A_SPI), yes)
+UNSUPPORTED_FEATURES += CONFIG_CH341A_SPI=yes
+else
+override CONFIG_CH341A_SPI = no
 endif
 endif
 
@@ -280,100 +348,23 @@
 else
 override CONFIG_LINUX_SPI = no
 endif
+ifeq ($(CONFIG_MSTARDDC_SPI), yes)
+UNSUPPORTED_FEATURES += CONFIG_MSTARDDC_SPI=yes
+else
+override CONFIG_MSTARDDC_SPI = no
+endif
+endif
+
+ifeq ($(TARGET_OS), Android)
+# Android on x86 (currently) does not provide raw PCI port I/O operations
+ifeq ($(CONFIG_RAYER_SPI), yes)
+UNSUPPORTED_FEATURES += CONFIG_RAYER_SPI=yes
+else
+override CONFIG_RAYER_SPI = no
+endif
 endif
 
 ###############################################################################
 # General architecture-specific settings.
 # Like above for the OS, below we verify user-supplied options depending on the target architecture.
 
-# Determine the destination processor architecture.
-# IMPORTANT: The following line must be placed before ARCH is ever used
-# (of course), but should come after any lines setting CC because the line
-# below uses CC itself.
-override ARCH := $(strip $(shell LC_ALL=C $(CC) $(CPPFLAGS) -E arch.h 2>/dev/null | grep -v '^\#' | grep '"' | cut -f 2 -d'"'))
-
-# PCI port I/O support is unimplemented on PPC/MIPS and unavailable on ARM.
-# Right now this means the drivers below only work on x86.
-ifneq ($(ARCH), x86)
-ifeq ($(CONFIG_NIC3COM), yes)
-UNSUPPORTED_FEATURES += CONFIG_NIC3COM=yes
-else
-override CONFIG_NIC3COM = no
-endif
-ifeq ($(CONFIG_NICREALTEK), yes)
-UNSUPPORTED_FEATURES += CONFIG_NICREALTEK=yes
-else
-override CONFIG_NICREALTEK = no
-endif
-ifeq ($(CONFIG_NICNATSEMI), yes)
-UNSUPPORTED_FEATURES += CONFIG_NICNATSEMI=yes
-else
-override CONFIG_NICNATSEMI = no
-endif
-ifeq ($(CONFIG_RAYER_SPI), yes)
-UNSUPPORTED_FEATURES += CONFIG_RAYER_SPI=yes
-else
-override CONFIG_RAYER_SPI = no
-endif
-ifeq ($(CONFIG_ATAHPT), yes)
-UNSUPPORTED_FEATURES += CONFIG_ATAHPT=yes
-else
-override CONFIG_ATAHPT = no
-endif
-ifeq ($(CONFIG_SATAMV), yes)
-UNSUPPORTED_FEATURES += CONFIG_SATAMV=yes
-else
-override CONFIG_SATAMV = no
-endif
-endif
-
-###############################################################################
-# Flash chip drivers and bus support infrastructure.
-
-CHIP_OBJS = jedec.o stm50.o w39.o w29ee011.o \
-	sst28sf040.o m29f400bt.o 82802ab.o pm49fl00x.o \
-	sst49lfxxxc.o sst_fwhub.o flashchips.o spi.o spi25.o spi25_statusreg.o \
-	opaque.o sfdp.o en29lv640b.o at45db.o
-
-###############################################################################
-# Library code.
-
-LIB_OBJS = layout.o flashrom.o udelay.o programmer.o
-
-###############################################################################
-# Frontend related stuff.
-
-CLI_OBJS = cli_classic.o cli_output.o print.o
-
-# Set the flashrom version string from the highest revision number of the checked out flashrom files.
-# Note to packagers: Any tree exported with "make export" or "make tarball"
-# will not require subversion. The downloadable snapshots are already exported.
-SVNVERSION := $(shell ./util/getrevision.sh -u)
-
-RELEASE := 0.9.7
-VERSION := $(RELEASE)-$(SVNVERSION)
-RELEASENAME ?= $(VERSION)
-
-SVNDEF := -D'FLASHROM_VERSION="$(VERSION)"'
-
-###############################################################################
-# Default settings of CONFIG_* variables.
-
-# Always enable internal/onboard support for now.
-CONFIG_INTERNAL ?= yes
-
-# Always enable serprog for now.
-CONFIG_SERPROG ?= yes
-
-# RayeR SPIPGM hardware support
-CONFIG_RAYER_SPI ?= yes
-
-# PonyProg2000 SPI hardware support
-CONFIG_PONY_SPI ?= yes
-
-# Always enable 3Com NICs for now.
-CONFIG_NIC3COM ?= yes
-
-# Enable NVIDIA graphics cards. Note: write and erase do not work properly.
-CONFIG_GFXNVIDIA ?= yes
-

=== ich_descriptors_tool/Makefile ===
#
# This file is part of the flashrom project.
#
# This Makefile works standalone, but it is usually called from the main
# Makefile in the flashrom directory.

PROGRAM=ich_descriptors_tool
EXTRAINCDIRS = ../../ .
DEPPATH = .dep
OBJATH = .obj
SHAREDSRC = ich_descriptors.c
SHAREDSRCDIR = ../..
# If your compiler spits out excessive warnings, run make WARNERROR=no
# You shouldn't have to change this flag.
WARNERROR ?= yes

SRC = $(wildcard *.c)

CC ?= gcc

# If the user has specified custom CFLAGS, all CFLAGS settings below will be
# completely ignored by gnumake.
CFLAGS ?= -Os -Wall -Wshadow
ifeq ($(TARGET_OS), DOS)
# DJGPP has odd uint*_t definitions which cause lots of format string warnings.
CFLAGS += -Wno-format
endif
ifeq ($(WARNERROR), yes)
CFLAGS += -Werror
endif


FLASHROM_CFLAGS += -MMD -MP -MF $(DEPPATH)/$(@F).d
# enables functions that populate the descriptor structs from plain binary dumps
FLASHROM_CFLAGS += -D ICH_DESCRIPTORS_FROM_DUMP
FLASHROM_CFLAGS += $(patsubst %,-I%,$(EXTRAINCDIRS))

OBJ = $(OBJATH)/$(SRC:%.c=%.o)

SHAREDOBJ = $(OBJATH)/$(notdir $(SHAREDSRC:%.c=%.o))

all:$(PROGRAM)$(EXEC_SUFFIX)

$(OBJ): $(OBJATH)/%.o : %.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(FLASHROM_CFLAGS) -o $@ -c $<

# this enables us to share source files without simultaneously sharing .o files
# with flashrom, which would lead to unexpected results (w/o running make clean)
$(SHAREDOBJ): $(OBJATH)/%.o : $(SHAREDSRCDIR)/%.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(FLASHROM_CFLAGS) -o $@ -c $<

$(PROGRAM)$(EXEC_SUFFIX): $(OBJ) $(SHAREDOBJ)
	$(CC) $(LDFLAGS) -o $(PROGRAM)$(EXEC_SUFFIX) $(OBJ) $(SHAREDOBJ)

clean:
	rm -f $(PROGRAM) $(PROGRAM).exe
	rm -rf $(DEPPATH) $(OBJATH)

# Include the dependency files.
-include $(shell mkdir -p $(DEPPATH) $(OBJATH) 2>/dev/null) $(wildcard $(DEPPATH)/*)

.PHONY: all clean

=== debian/changelog ===
flashrom (0.9.9~rc1+r1942-1) unstable; urgency=medium

  * Acknowledge NMU, thanks Anibal Monsalve Salazar! (Closes: #775428).
  * New upstream release (Closes: #786917).
      + Dediprog SF100 support is now enabled by default (Closes: #639957).
      + debian/patches/20_svn_version.patch: Drop, no longer needed (if the
        tarball is generated via 'make tarball' from svn checkout).
      + debian/patches/mips-fix-internal.patch: Drop, fixed upstream.
  * New build-depends: libusb-1.0-0-dev (in addition to libusb-dev).
  * Updated build-depends: libftdi-dev -> libftdi1-dev (Closes: #810372).

 -- Uwe Hermann <uwe@debian.org>  Tue, 23 Feb 2016 19:34:07 +0100

flashrom (0.9.7+r1852-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS on mipsel.
    Patch by Dejan Latinovic <Dejan.Latinovic@imgtec.com>.
    Add mips-fix-internal.patch.
    Closes: #775428.

 -- Anibal Monsalve Salazar <anibal@debian.org>  Wed, 14 Oct 2015 09:21:36 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: electronics
 Priority: extra
 Maintainer: Uwe Hermann <uwe@debian.org>
-Build-Depends: cdbs, debhelper (>= 9.0.0), libpci-dev, libftdi-dev
+Build-Depends: cdbs, debhelper (>= 9.0.0), libpci-dev, libusb-dev, libusb-1.0-0-dev, libftdi1-dev
 Standards-Version: 3.9.6
 Homepage: http://www.flashrom.org

=== debian/watch ===
# We track upstream svn revisions, thus no need for a watch file.

## flashrom 0.9.9+r1954

=== Makefile ===
--- 
+++ 
@@ -314,7 +314,7 @@
 else
 override CONFIG_PONY_SPI = no
 endif
-# Dediprog, USB-Blaster, PICkit2, CH341A and FT2232 are not supported with libpayload (missing libusb support)
+# Dediprog, USB-Blaster, PICkit2, CH341A and FT2232 are not supported with libpayload (missing libusb support).
 ifeq ($(CONFIG_DEDIPROG), yes)
 UNSUPPORTED_FEATURES += CONFIG_DEDIPROG=yes
 else
@@ -343,6 +343,8 @@
 endif
 
 ifneq ($(TARGET_OS), Linux)
+# Android is handled internally as separate OS, but it supports CONFIG_LINUX_SPI and CONFIG_MSTARDDC_SPI
+ifneq ($(TARGET_OS), Android)
 ifeq ($(CONFIG_LINUX_SPI), yes)
 UNSUPPORTED_FEATURES += CONFIG_LINUX_SPI=yes
 else
@@ -352,6 +354,7 @@
 UNSUPPORTED_FEATURES += CONFIG_MSTARDDC_SPI=yes
 else
 override CONFIG_MSTARDDC_SPI = no
+endif
 endif
 endif
 
@@ -365,6 +368,3 @@
 endif
 
 ###############################################################################
-# General architecture-specific settings.
-# Like above for the OS, below we verify user-supplied options depending on the target architecture.
-

=== debian/changelog ===
flashrom (0.9.9+r1954-1) unstable; urgency=medium

  * New upstream release.
  * Don't build-depend on libftdi1-dev on Hurd, it's not available.

 -- Uwe Hermann <uwe@debian.org>  Sun, 13 Mar 2016 20:41:00 +0100

flashrom (0.9.9~rc1+r1946-1) unstable; urgency=medium

  * New upstream release (Closes: #788426, #802342).
      + Partial support for alpha, hppa, m68k, sh, and s390 (Closes: 774405).
  * debian/control:
      + On kFreeBSD only build-depend on libusb-1.0-0-dev, that
        package also includes the old libusb 0.1 API (Closes: #815947).
        Thanks Steven Chamberlain for the patch!
      + Don't build-depend on libusb-1.0-0-dev on Hurd, it's not available.
      + Add pkg-config to build-depends, since it is used by the upstream
        Makefile. Otherwise the Makefile uses hardcoded guesses, which
        are not always correct.
      + Drop "Recommends: dmidecode [any-i386 any-amd64 ia64 armhf]".
        Upstream has its own code now, no longer uses dmidecode by default.
  * debian/rules: Add "export DEB_BUILD_MAINT_OPTIONS = hardening=+all".
  * Standards-Version: 3.9.7 (no changes required).
  * Package description: Update list of supported devices.

 -- Uwe Hermann <uwe@debian.org>  Tue, 01 Mar 2016 00:07:45 +0100

=== debian/control ===
Source: flashrom
Section: electronics
Priority: extra
Maintainer: Uwe Hermann <uwe@debian.org>
Build-Depends: cdbs, debhelper (>= 9.0.0), pkg-config, libpci-dev, libusb-dev [!kfreebsd-any], libusb-1.0-0-dev [!hurd-i386], libftdi1-dev [!hurd-i386]
Standards-Version: 3.9.7
Homepage: http://www.flashrom.org

Package: flashrom
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Identify, read, write, erase, and verify BIOS/ROM/flash chips
 flashrom is a tool for identifying, reading, writing, verifying and erasing
 flash chips. It's often used to flash BIOS/EFI/coreboot/firmware/optionROM
 images in-system using a supported mainboard, but it also supports flashing of
 network cards (NICs), SATA controller cards, and other external devices which
 can program flash chips.
 .
 It supports a wide range of DIP32, PLCC32, DIP8, SO8/SOIC8, TSOP32/40/48,
 and BGA chips, which use various protocols such as LPC, FWH, parallel
 flash, or SPI.
 .
 The tool can be used to flash BIOS/firmware images for example -- be it
 proprietary BIOS images or coreboot (previously known as LinuxBIOS) images.
 .
 It can also be used to read the current existing BIOS/firmware from a
 flash chip.
 .
 Currently supported programmers include:
 .
   * internal (for in-system flashing in the mainboard)
   * dummy (virtual programmer for testing flashrom)
   * nic3com (for flash ROMs on 3COM network cards)
   * nicrealtek (for flash ROMs on Realtek and SMC 1211 network cards)
   * nicnatsemi (for flash ROMs on National Semiconductor DP838* network cards)
   * nicintel (for parallel flash ROMs on Intel 10/100Mbit network cards)
   * gfxnvidia (for flash ROMs on NVIDIA graphics cards)
   * drkaiser (for flash ROMs on Dr. Kaiser PC-Waechter PCI cards)
   * satasii (for flash ROMs on Silicon Image SATA/IDE controllers)
   * satamv (for flash ROMs on Marvell SATA controllers)
   * atahpt (for flash ROMs on Highpoint ATA/RAID controllers)
   * atavia (for flash ROMs on VIA VT6421A SATA controllers)
   * atapromise (for flash ROMs on Promise PDC2026x ATA/RAID controllers)
   * it8212 (for flash ROMs on ITE IT8212F ATA/RAID controller)
   * ft2232_spi (for SPI flash ROMs attached to an FT2232/FT4232H/FT232H family
     based USB SPI programmer), including the DLP Design DLP-USB1232H,
     FTDI FT2232H Mini-Module, FTDI FT4232H Mini-Module, openbiosprog-spi,
     Amontec JTAGkey/JTAGkey-tiny/JTAGkey-2, Dangerous Prototypes Bus Blaster,
     Olimex ARM-USB-TINY/-H, Olimex ARM-USB-OCD/-H, TIAO/DIYGADGET USB
     Multi-Protocol Adapter (TUMPA), TUMPA Lite, GOEPEL PicoTAP,
     Google Servo v1/v2, and FIC OpenMoko Neo1973 Debug board.
   * serprog (for flash ROMs attached to a programmer speaking serprog),
     including AVR flasher by Urja Rannikko, AVR flasher by eightdot,
     Arduino Mega flasher by fritz, InSystemFlasher by Juhana Helovuo,
     and atmegaXXu2-flasher by Stefan Tauner.
   * buspirate_spi (for SPI flash ROMs attached to a Bus Pirate)
   * dediprog (for SPI flash ROMs attached to a Dediprog SF100)
   * rayer_spi (for SPI flash ROMs attached to a RayeR parport based programmer)
   * pony_spi (for SPI flash ROMs attached to a SI-Prog serial port
     bitbanging adapter)
   * nicintel_spi (for SPI flash ROMs on Intel Gigabit network cards)
   * ogp_spi (for SPI flash ROMs on Open Graphics Project graphics card)
   * linux_spi (for SPI flash ROMs accessible via /dev/spidevX.Y on Linux)
   * usbblaster_spi (for SPI flash ROMs attached to an Altera USB-Blaster)
   * nicintel_eeprom (for SPI EEPROMs on Intel Gigabit network cards)
   * mstarddc_spi (for SPI flash ROMs accessible through DDC in MSTAR-equipped
     displays)
   * pickit2_spi (for SPI flash ROMs accessible via Microchip PICkit2)
   * ch341a_spi (for SPI flash ROMs attached to WCH CH341A)

## flashrom 1.0

=== util/ich_descriptors_tool/Makefile ===
#
# This file is part of the flashrom project.
#
# This Makefile works standalone, but it is usually called from the main
# Makefile in the flashrom directory.

PROGRAM=ich_descriptors_tool
EXTRAINCDIRS = ../../ .
DEPPATH = .dep
OBJATH = .obj
SHAREDSRC = ich_descriptors.c
SHAREDSRCDIR = ../..
# If your compiler spits out excessive warnings, run make WARNERROR=no
# You shouldn't have to change this flag.
WARNERROR ?= yes

SRC = $(wildcard *.c)

CC ?= gcc

# If the user has specified custom CFLAGS, all CFLAGS settings below will be
# completely ignored by gnumake.
CFLAGS ?= -Os -Wall -Wshadow

override TARGET_OS := $(shell $(CC) $(CPPFLAGS) -E $(SHAREDSRCDIR)/os.h | grep -v '^\#' | grep '"' | \
			cut -f 2 -d'"')

ifeq ($(TARGET_OS), DOS)
EXEC_SUFFIX := .exe
# DJGPP has odd uint*_t definitions which cause lots of format string warnings.
CFLAGS += -Wno-format
endif

ifeq ($(TARGET_OS), MinGW)
EXEC_SUFFIX := .exe
# Some functions provided by Microsoft do not work as described in C99 specifications. This macro fixes that
# for MinGW. See http://sourceforge.net/p/mingw-w64/wiki2/printf%20and%20scanf%20family/ */
FLASHROM_CFLAGS += -D__USE_MINGW_ANSI_STDIO=1
endif

ifeq ($(WARNERROR), yes)
CFLAGS += -Werror
endif


FLASHROM_CFLAGS += -MMD -MP -MF $(DEPPATH)/$(@F).d
# enables functions that populate the descriptor structs from plain binary dumps
FLASHROM_CFLAGS += -D ICH_DESCRIPTORS_FROM_DUMP_ONLY
FLASHROM_CFLAGS += $(patsubst %,-I%,$(EXTRAINCDIRS))

OBJ = $(OBJATH)/$(SRC:%.c=%.o)

SHAREDOBJ = $(OBJATH)/$(notdir $(SHAREDSRC:%.c=%.o))

all:$(PROGRAM)$(EXEC_SUFFIX)

$(OBJ): $(OBJATH)/%.o : %.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(FLASHROM_CFLAGS) -o $@ -c $<

# this enables us to share source files without simultaneously sharing .o files
# with flashrom, which would lead to unexpected results (w/o running make clean)
$(SHAREDOBJ): $(OBJATH)/%.o : $(SHAREDSRCDIR)/%.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(FLASHROM_CFLAGS) -o $@ -c $<

$(PROGRAM)$(EXEC_SUFFIX): $(OBJ) $(SHAREDOBJ)
	$(CC) $(LDFLAGS) -o $(PROGRAM)$(EXEC_SUFFIX) $(OBJ) $(SHAREDOBJ)

clean:
	rm -f $(PROGRAM) $(PROGRAM).exe
	rm -rf $(DEPPATH) $(OBJATH)

# Include the dependency files.
-include $(shell mkdir -p $(DEPPATH) $(OBJATH) 2>/dev/null) $(wildcard $(DEPPATH)/*)

.PHONY: all clean

=== debian/changelog ===
flashrom (1.0-1) unstable; urgency=medium

  * New upstream version. (Closes: #892065)
  * New maintainer. (Closes: #919434)
  * debian/control: add myself to Uploaders field. (Closes: #919050)
  * Bump debhelper version to 10.
  * Bump standards version to 4.2.1.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Thu, 04 Oct 2018 08:57:59 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: flashrom
 Section: electronics
-Priority: extra
-Maintainer: Uwe Hermann <uwe@debian.org>
-Build-Depends: cdbs, debhelper (>= 9.0.0), pkg-config, libpci-dev, libusb-dev [!kfreebsd-any], libusb-1.0-0-dev [!hurd-i386], libftdi1-dev [!hurd-i386]
-Standards-Version: 3.9.7
+Priority: optional
+Maintainer: Gürkan Myczko <gurkan@phys.ethz.ch>
+Build-Depends: cdbs, debhelper (>= 10), pkg-config, libpci-dev, libusb-dev [!kfreebsd-any], libusb-1.0-0-dev [!hurd-i386], libftdi1-dev [!hurd-i386]
+Standards-Version: 4.2.1
 Homepage: http://www.flashrom.org
 
 Package: flashrom

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/class/makefile.mk

DEB_MAKE_INSTALL_TARGET := install PREFIX=$(CURDIR)/debian/flashrom/usr

# Reduce the number of unneeded dependencies with --as-needed.
LDFLAGS += "-Wl,--as-needed"

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

post-patches::
	@# Copy udev rules file into debian/ so that dh_installudev finds it.
	cp util/z60_flashrom.rules debian/flashrom.udev

clean::
	rm -f .dependencies .features .libdeps
	rm -f debian/flashrom.udev

common-binary-post-install-arch:: list-missing

## flashrom 1.0.1

=== Makefile ===
--- 
+++ 
@@ -63,7 +63,7 @@
 WARNERROR ?= yes
 
 ifeq ($(WARNERROR), yes)
-CFLAGS += -Werror
+CFLAGS += -Werror -Wno-error=deprecated-declarations
 endif
 
 ifdef LIBS_BASE
@@ -367,4 +367,3 @@
 endif
 endif
 
-###############################################################################

=== debian/changelog ===
flashrom (1.0.1-1) experimental; urgency=medium

  * New upstream version.
  * Apply github pr#71 to fix libusb call.
  * Add Jeremiah C. Foster as co-maintainer.
  * Apply patch reproducible_build, thanks Chris Lamb. (Closes: #834957)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Thu, 31 Jan 2019 09:58:20 +0100

## flashrom 1.1

=== Makefile ===
--- 
+++ 
@@ -12,10 +12,6 @@
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
 #
 
 PROGRAM = flashrom
@@ -63,7 +59,7 @@
 WARNERROR ?= yes
 
 ifeq ($(WARNERROR), yes)
-CFLAGS += -Werror -Wno-error=deprecated-declarations
+CFLAGS += -Werror
 endif
 
 ifdef LIBS_BASE
@@ -97,10 +93,11 @@
 
 # HOST_OS is only used to work around local toolchain issues.
 HOST_OS ?= $(shell uname)
-ifeq ($(HOST_OS), MINGW32_NT-5.1)
+ifeq ($(findstring MINGW, $(HOST_OS)), MINGW)
 # Explicitly set CC = gcc on MinGW, otherwise: "cc: command not found".
 CC = gcc
 endif
+
 ifneq ($(HOST_OS), SunOS)
 STRIP_ARGS = -s
 endif
@@ -157,12 +154,22 @@
 else
 override CONFIG_PONY_SPI = no
 endif
-# Dediprog, USB-Blaster, PICkit2, CH341A and FT2232 are not supported under DOS (missing USB support).
+# Digilent SPI, Dediprog, Developerbox, USB-Blaster, PICkit2, CH341A and FT2232 are not supported under DOS (missing USB support).
+ifeq ($(CONFIG_DIGILENT_SPI), yes)
+UNSUPPORTED_FEATURES += CONFIG_DIGILENT_SPI=yes
+else
+override CONFIG_DIGILENT_SPI = no
+endif
 ifeq ($(CONFIG_DEDIPROG), yes)
 UNSUPPORTED_FEATURES += CONFIG_DEDIPROG=yes
 else
 override CONFIG_DEDIPROG = no
 endif
+ifeq ($(CONFIG_DEVELOPERBOX_SPI), yes)
+UNSUPPORTED_FEATURES += CONFIG_DEVELOPERBOX_SPI=yes
+else
+override CONFIG_DEVELOPERBOX_SPI = no
+endif
 ifeq ($(CONFIG_FT2232_SPI), yes)
 UNSUPPORTED_FEATURES += CONFIG_FT2232_SPI=yes
 else
@@ -182,6 +189,12 @@
 UNSUPPORTED_FEATURES += CONFIG_CH341A_SPI=yes
 else
 override CONFIG_CH341A_SPI = no
+endif
+# libjaylink is also not available for DOS
+ifeq ($(CONFIG_JLINK_SPI), yes)
+UNSUPPORTED_FEATURES += CONFIG_JLINK_SPI=yes
+else
+override CONFIG_JLINK_SPI = no
 endif
 endif
 
@@ -314,11 +327,16 @@
 else
 override CONFIG_PONY_SPI = no
 endif
-# Dediprog, USB-Blaster, PICkit2, CH341A and FT2232 are not supported with libpayload (missing libusb support).
+# Dediprog, Developerbox, USB-Blaster, PICkit2, CH341A and FT2232 are not supported with libpayload (missing libusb support).
 ifeq ($(CONFIG_DEDIPROG), yes)
 UNSUPPORTED_FEATURES += CONFIG_DEDIPROG=yes
 else
 override CONFIG_DEDIPROG = no
+endif
+ifeq ($(CONFIG_DEVELOPERBOX_SPI), yes)
+UNSUPPORTED_FEATURES += CONFIG_DEVELOPERBOX_SPI=yes
+else
+override CONFIG_DEVELOPERBOX_SPI = no
 endif
 ifeq ($(CONFIG_FT2232_SPI), yes)
 UNSUPPORTED_FEATURES += CONFIG_FT2232_SPI=yes
@@ -345,25 +363,9 @@
 ifneq ($(TARGET_OS), Linux)
 # Android is handled internally as separate OS, but it supports CONFIG_LINUX_SPI and CONFIG_MSTARDDC_SPI
 ifneq ($(TARGET_OS), Android)
+ifeq ($(CONFIG_LINUX_MTD), yes)
+UNSUPPORTED_FEATURES += CONFIG_LINUX_MTD=yes
+else
+override CONFIG_LINUX_MTD = no
+endif
 ifeq ($(CONFIG_LINUX_SPI), yes)
-UNSUPPORTED_FEATURES += CONFIG_LINUX_SPI=yes
-else
-override CONFIG_LINUX_SPI = no
-endif
-ifeq ($(CONFIG_MSTARDDC_SPI), yes)
-UNSUPPORTED_FEATURES += CONFIG_MSTARDDC_SPI=yes
-else
-override CONFIG_MSTARDDC_SPI = no
-endif
-endif
-endif
-
-ifeq ($(TARGET_OS), Android)
-# Android on x86 (currently) does not provide raw PCI port I/O operations
-ifeq ($(CONFIG_RAYER_SPI), yes)
-UNSUPPORTED_FEATURES += CONFIG_RAYER_SPI=yes
-else
-override CONFIG_RAYER_SPI = no
-endif
-endif
-

=== debian/changelog ===
flashrom (1.1-1) unstable; urgency=medium

  * New upstream version.
  * debian/watch: activated.
  * debian/patches: fixed upstream.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Sun, 07 Jul 2019 11:21:58 +0200

=== debian/control ===
--- 
+++ 
@@ -2,6 +2,7 @@
 Section: electronics
 Priority: optional
 Maintainer: Gürkan Myczko <gurkan@phys.ethz.ch>
+Uploaders: Jeremiah C. Foster <jeremiah.foster@puri.sm>
 Build-Depends: cdbs, debhelper (>= 10), pkg-config, libpci-dev, libusb-dev [!kfreebsd-any], libusb-1.0-0-dev [!hurd-i386], libftdi1-dev [!hurd-i386]
 Standards-Version: 4.2.1
 Homepage: http://www.flashrom.org

=== debian/rules ===
--- 
+++ 
@@ -20,4 +20,3 @@
 	rm -f debian/flashrom.udev
 
 common-binary-post-install-arch:: list-missing
-
